<?php

namespace Superrobota\Mailing;

use User;

class Mailing
{
    /**
     * $mailing object.
     */
    protected $mailing;

    /**
     * Constructor.
     */
    public function __construct(\Superrobota\Mailing\Interfaces\MailingRepositoryInterface $mailing)
    {
        $this->mailing = $mailing;
    }

    /**
     * Returns count of mailing.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.mailing.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->mailing->pushCriteria(new \Litepie\Superrobota\Repositories\Criteria\MailingUserCriteria());
        }

        $mailing = $this->mailing->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('mailing::' . $view, compact('mailing'))->render();
    }
}
