<?php

namespace Superrobota\Mailing\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class MailingTransformer extends TransformerAbstract
{
    public function transform(\Superrobota\Mailing\Models\Mailing $mailing)
    {
        return [
            'id'                => $mailing->getRouteKey(),
            'key'               => [
                'public'    => $mailing->getPublicKey(),
                'route'     => $mailing->getRouteKey(),
            ], 
            'text'              => $mailing->text,
            'to'                => $mailing->to,
            'topic'             => $mailing->topic,
            'frequency'         => $mailing->frequency,
            'template_id'       => $mailing->template_id,
            'url'               => [
                'public'    => trans_url('mailing/'.$mailing->getPublicKey()),
                'user'      => guard_url('mailing/mailing/'.$mailing->getRouteKey()),
            ], 
            'status'            => trans('app.'.$mailing->status),
            'created_at'        => format_date($mailing->created_at),
            'updated_at'        => format_date($mailing->updated_at),
        ];
    }
}